function ajax_view_log(view_file) {
	jQuery.ajax({
		url: ajax_var.url,
		method: 'POST',
		data: {
			'action': 'wpsa_view_log',
			'nonce': ajax_var.nonce,
			'file': view_file
		},
		beforeSend: function () {
			jQuery("#loading").show();
		},
		success: function (data) {
			jQuery("#loading").hide();
			jQuery('#error_messages').html('');
			jQuery(".li .filename").css("font-weight", "normal");
			let filename = view_file;
			filename = '#li_' + filename.replace(/\_/g, "").replace(".", "") + " .filename";
			jQuery(filename).css("font-weight", "bold");
			jQuery('#log').html(user_friendly_log_display(data));
		},
		error: function (errorThrown) {
			jQuery("#loading").hide();
			jQuery('#error_messages').prepend("<div class='message' style='border-color:#d63638'>Log details cannot be loaded.</div>");
		}
	});
}

function ajax_view_log_shortcode(view_file) {
	jQuery.ajax({
		url: ajax_var.url,
		method: 'POST',
		data: {
			'action': 'wpsa_view_log_shortcode',
			'nonce': ajax_var.nonce,
			'file': view_file
		},
		beforeSend: function () {
			jQuery("#loading").show();
		},
		success: function (data) {
			jQuery("#loading").hide();
			jQuery('#error_messages').html('');
			jQuery(".li .filename").css("font-weight", "normal");
			var filename = view_file;
			filename = '#li_' + filename.replace(/\_/g, "").replace(".", "") + " .filename";
			jQuery(filename).css("font-weight", "bold");
			jQuery('#log').html(user_friendly_log_display(data));
		},
		error: function (errorThrown) {
			jQuery("#loading").hide();
			jQuery('#error_messages').prepend("<div class='message' style='border-color:#d63638'>Log details cannot be loaded.</div>");
		}
	});
}

function ajax_delete_log(delete_file) {
	jQuery.ajax({
		url: ajax_var.url,
		method: 'POST',
		data: {
			'action': 'wpsa_delete_log',
			'nonce': ajax_var.nonce,
			'file': delete_file
		},
		beforeSend: function () {
			jQuery("#loading").show();
		},
		success: function (data) {
			jQuery("#loading").hide();
			jQuery('#error_messages').html('');
			jQuery('#log').html(data);
			delete_file = delete_file.replace(/\./g, "");
			delete_file = delete_file.replace(/\_/g, "");
			jQuery('#li_' + delete_file).remove();
		},
		error: function (errorThrown) {
			jQuery("#loading").hide();
			jQuery('#error_messages').prepend("<div class='message' style='border-color:#d63638'>Log cannot be deleted.</div>");
		}
	});
}

function add_tag(ip) {
	jQuery('#meta_tag').show();
	jQuery('#ip').val(ip);
}

function cancel_tag() {
	jQuery('#tag').css("border-color", "#2271b1");
	jQuery('#ip').val('');
	jQuery('#tag').val('');
}

function save_tag() {
	let ip = jQuery('#ip').val();
	let tag = jQuery('#tag').val();

	jQuery('#ip').val('');
	jQuery('#tag').val('');

	if (tag == null || tag == "") {
		jQuery('#tag').css("border-color", "#d63638");
	} else {
		jQuery('#meta_tag').hide();
		jQuery.ajax({
			url: ajax_var.url,
			method: 'POST',
			data: {
				'action': 'wpsa_add_tag',
				'nonce': ajax_var.nonce,
				'ip': ip,
				'tag': tag
			},
			beforeSend: function () {
				jQuery("#loading").show();
			},
			success: function (data) {
				jQuery("#loading").hide();
				jQuery('#log').html(data);
				setTimeout(function () {
					location.reload();
				}, 3000);
			},
			error: function (errorThrown) {
				jQuery("#loading").hide();
				jQuery('#log').html("<div class='message' style='border-color:#d63638'>Tag cannot be added.</div>");
			}
		});

	}
}

function save_settings() {
	let error = false;

	let tag_frequency = jQuery('#tag_frequency').val();
	let session_duration = jQuery('#session_duration').val();
	let refresh_todays_log_duration = jQuery('#refresh_todays_log_duration').val();
	let max_cache_records = jQuery('#max_cache_records').val();
	let max_database_records = jQuery('#max_database_records').val();

	jQuery("#tag_frequency").css('border-color', '#00a0c8');
	jQuery("#session_duration").css('border-color', '#00a0c8');
	jQuery("#refresh_todays_log_duration").css('border-color', '#00a0c8');
	jQuery("#max_cache_records").css('border-color', '#00a0c8');
	jQuery("#max_database_records").css('border-color', '#00a0c8');

	if ((!isInt(tag_frequency)) || (tag_frequency < 1)) {
		jQuery("#plugin-messages").append(
			"<div class='notice notice-error is-dismissible'><p><strong>Please provide a valid tag frequency greater than 1.</strong></p><button type='button' onclick='jQuery(this).parent().hide();' class='notice-dismiss'><span class='screen-reader-text'>Dismiss this notice.</span></button></div>"
		);
		jQuery("#tag_frequency").css('border-color', '#d63638');
		error = true;
	}

	if ((!isInt(session_duration)) || (session_duration < 1)) {
		jQuery("#plugin-messages").append(
			"<div class='notice notice-error is-dismissible'><p><strong>Please provide a valid session duration greater than 1.</strong></p><button type='button' onclick='jQuery(this).parent().hide();' class='notice-dismiss'><span class='screen-reader-text'>Dismiss this notice.</span></button></div>"
		);
		jQuery("#session_duration").css('border-color', '#d63638');
		error = true;
	}

	if ((!isNumeric(refresh_todays_log_duration)) || (refresh_todays_log_duration < 0)) {
		jQuery("#plugin-messages").append(
			"<div class='notice notice-error is-dismissible'><p><strong>Please provide a valid refresh duration greater than 0.</strong></p><button type='button' onclick='jQuery(this).parent().hide();' class='notice-dismiss'><span class='screen-reader-text'>Dismiss this notice.</span></button></div>"
		);
		jQuery("#refresh_todays_log_duration").css('border-color', '#d63638');
		error = true;
	}

	if ((!isNumeric(max_cache_records)) || (max_cache_records < 0)) {
		jQuery("#plugin-messages").append(
			"<div class='notice notice-error is-dismissible'><p><strong>Please provide a valid cache record limit greater than 0.</strong></p><button type='button' onclick='jQuery(this).parent().hide();' class='notice-dismiss'><span class='screen-reader-text'>Dismiss this notice.</span></button></div>"
		);
		jQuery("#max_cache_records").css('border-color', '#d63638');
		error = true;
	}

	if ((!isNumeric(max_database_records)) || (max_database_records < 0)) {
		jQuery("#plugin-messages").append(
			"<div class='notice notice-error is-dismissible'><p><strong>Please provide a valid whole number as database record limit.</strong></p><button type='button' onclick='jQuery(this).parent().hide();' class='notice-dismiss'><span class='screen-reader-text'>Dismiss this notice.</span></button></div>"
		);
		jQuery("#max_database_records").css('border-color', '#d63638');
		error = true;
	}

	if (error) {
		jQuery('html, body').animate({
			scrollTop: jQuery('#wpsamain').offset().top - 30
		}, 100, 'swing');
		return;
	}

	jQuery.ajax({
		url: ajax_var.url,
		method: 'POST',
		data: {
			'action': 'wpsa_save_settings',
			'nonce': ajax_var.nonce,
			'api_key': jQuery('#api_key').val(),
			'ignore_files': jQuery('#ignore_files').val(),
			'tag_frequency': jQuery('#tag_frequency').val(),
			'session_duration': jQuery('#session_duration').val(),
			'meta_tags': jQuery('#meta_tags').val(),
			'ignore_my_visits_cookie': jQuery('#ignore_my_visits_cookie').is(':checked'),
			'ignore_my_visits_ip': jQuery('#ignore_my_visits_ip').is(':checked'),
			'ignore_bots': jQuery('#ignore_bots').is(':checked'),
			'anonymize_ip': jQuery('#anonymize_ip').is(':checked'),
			'stop_logging': jQuery('#stop_logging').is(':checked'),
			'reset_visitor_count': jQuery('#reset_visitor_count').is(':checked'),
			'refresh_todays_log_duration': jQuery('#refresh_todays_log_duration').val(),
			'max_cache_records': jQuery('#max_cache_records').val(),
			'max_database_records': jQuery('#max_database_records').val()
		},
		beforeSend: function () {
			jQuery("#wpsa_ajax_save_button").val("Saving");
		},
		success: function (data) {
			jQuery("#plugin-messages").append(
				"<div class='notice notice-success is-dismissible'><p><strong>Settings successfully saved.</strong></p><button type='button' onclick='jQuery(this).parent().hide();' class='notice-dismiss'><span class='screen-reader-text'>Dismiss this notice.</span></button></div>"
			);
			jQuery("#wpsa_ajax_save_button").val("Save");
			close_section(jQuery("#wpsa_ajax_save_button"));

			jQuery('#reset_toggle_switch').prop('checked', false);

			jQuery("#tag_frequency").css('border-color', '#00a0c8');
			jQuery("#session_duration").css('border-color', '#00a0c8');
			jQuery("#refresh_todays_log_duration").css('border-color', '#00a0c8');
			jQuery("#max_cache_records").css('border-color', '#00a0c8');
			jQuery("#max_database_records").css('border-color', '#00a0c8');

			jQuery('html, body').animate({
				scrollTop: jQuery('#wpsamain').offset().top - 30
			}, 100, 'swing');
		},
		error: function (errorThrown) {
			jQuery("#plugin-messages").append(
				"<div class='notice notice-error is-dismissible'><p><strong>Settings cannot be saved successfully.</strong></p><button type='button' onclick='jQuery(this).parent().hide();' class='notice-dismiss'><span class='screen-reader-text'>Dismiss this notice.</span></button></div>"
			);
			jQuery("#wpsa_ajax_save_button").val("Save");
		}
	});
}

function open_section(which) {
	which.closest('.section').find('.collapse').show(100);
	which.closest('.section').find('.min').show();
	which.closest('.section').find('.max').hide();
}

function close_section(which) {
	which.closest('.section').find('.collapse').hide(100);
	which.closest('.section').find('.min').hide();
	which.closest('.section').find('.max').show();
}

function view_tag_logs(classname) {
	jQuery("#wpsa #log .all").hide();
	jQuery("#wpsa #log ." + classname).show();
}

if (window.location.hash === '#wpsamain') {
	let hash = window.location.hash;

	if (jQuery(hash).length) {
		jQuery('html, body').animate({
			scrollTop: jQuery(hash).offset().top - 30
		}, 900, 'swing');
	}
}

function user_friendly_log_display(data) {
	var days = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
	var months = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];

	return data = data.replace(/(\d\d\d\d-\d\d-\d\dT\d\d:\d\d:\d\dZ)/g, (matched, index, original) => {
		let str = new Date(matched).toLocaleString('en-US', { timeZone: Intl.DateTimeFormat().resolvedOptions().timeZone });
		str = str.split(',').map(function (value) {
			return value.trim();
		});
		let str_time = str[1];
		let str_date = new Date(str[0]);
		str_date = days[str_date.getDay()] + ', ' + str_date.getDate() + ' ' + months[str_date.getMonth()] + ' ' + str_date.getFullYear();
		str = str_time + ' on ' + str_date;
		return '@ ' + str;
	});
}

jQuery(document).ready(function () {
	let data = jQuery('#log').html();
	data = user_friendly_log_display(data);
	jQuery('#log').html(data);

	jQuery('#start_date').datepicker({ dateFormat : 'yy-mm-dd' }).datepicker("setDate", -6);
	jQuery('#end_date').datepicker({ dateFormat : 'yy-mm-dd' }).datepicker("setDate", new Date());
});

jQuery(window).scroll(function () {
	if (jQuery(this).scrollTop()) {
		jQuery('#toTop').fadeIn();
	} else {
		jQuery('#toTop').fadeOut();
	}
});

jQuery(window).click(function () {
	jQuery('#toTop').fadeOut();
});

jQuery("#toTop").click(function () {
	//1 second of animation time
	//html works for FFX but not Chrome
	//body works for Chrome but not FFX
	//This strange selector seems to work universally
	jQuery("html, body").animate({ scrollTop: 0 }, 1000);
});

function isInt(str) {
	return !isNaN(str) && Number.isInteger(parseFloat(str));
}

function isNumeric(num) {
	return !isNaN(num)
}

function generate_report() {
	let start_date = jQuery("#start_date").val();
	let end_date = jQuery("#end_date").val();
	let category_group = jQuery('#category_group option').filter(':selected').val();
	let remove_bot_visits = jQuery('#remove_bot_visits').is(':checked');
	let remove_admin_visits = jQuery('#remove_admin_visits').is(':checked');
	let sort = jQuery('#sort option').filter(':selected').val();
	let direction = jQuery('#direction option').filter(':selected').val();

	jQuery.ajax({
		url: ajax_var.url,
		method: 'POST',
		data: {
			'action': 'wpsa_generate_report',
			'nonce': ajax_var.nonce,
			'start_date': start_date,
			'end_date': end_date,
			'category_group': category_group,
			'remove_bot_visits': remove_bot_visits,
			'remove_admin_visits': remove_admin_visits,
			'sort': sort,
			'direction': direction
		},
		beforeSend: function () {
			jQuery("#wpsa_ajax_generate_report__button").val("Generating");
			jQuery("#table_message").html('<tr><td colspan = "6">Generating data ...</td></tr>');
		},
		success: function (data) {
			jQuery("#wpsa_ajax_generate_report__button").val("Generate");
			jQuery("#table_message").html('<tr><td colspan = "6">No data available.</td></tr>');
			if ( '' != data ) {
				jQuery("#table_message").html(data);
			}
		},
		error: function (errorThrown) {
			jQuery("#wpsa_ajax_generate_report__button").val("Generating");
			jQuery("#table_message").html('<tr><td colspan = "6">Generating data ...</td></tr>');
		}
	});
}

function open_logs() {
	jQuery('.log_section').find('.min').show();
	jQuery('.log_section').find('.max').hide();
	jQuery('.collapse1').show(100);
	jQuery('.collapse2').show(100);
	jQuery('.collapse3').show(100);
	jQuery('#sidebar').addClass('section_left');
	jQuery('#sidebar').removeClass('section');
}

function close_logs() {
	jQuery('.log_section').find('.min').hide();
	jQuery('.log_section').find('.max').show();
	jQuery('.collapse1').hide(100);
	jQuery('.collapse2').hide(100);
	jQuery('.collapse3').hide(100);
	jQuery('#sidebar').addClass('section');
	jQuery('#sidebar').removeClass('section_left');
}