<?php
/**
 * File for uninstalling plugin.
 * Unistalls the option name.
 * Do not call this file directly.
 *
 * @package wpsa.
 */

// If uninstall.php is not called by WordPress, die.
if ( ! defined( 'WP_UNINSTALL_PLUGIN' ) ) {
	wp_die( "<h2 style='color:red'>Plugin Error - WP Smart Analytics</h2><p>Do not call this file directly. Uninstall from plugin administrator screen.</p>" );
} else {
	// Options.
	delete_option( 'SHA_SECRET_KEY' );
	delete_option( 'SHA_SECRET_IV' );
	delete_option( 'WPSA_API_KEY' );
	delete_option( 'IGNORE_FILES' );
	delete_option( 'TAG_FREQUENCY' );
	delete_option( 'SESSION_DURATION' );
	delete_option( 'COOKIE' );
	delete_option( 'IP_STRING' );
	delete_option( 'IGNORE_BOTS' );
	delete_option( 'ANONYMIZE_IP' );
	delete_option( 'STOP_LOGGING' );
	delete_option( 'VISITOR_COUNT' );
	delete_option( 'REFRESH_TODAYS_LOG_DURATION' );
	delete_option( 'MAX_CACHE_RECORDS' );
	delete_option( 'MAX_DATABASE_RECORDS' );

	$upload_dir = wp_upload_dir();
	$dir        = trailingslashit( $upload_dir['basedir'] ) . '/wp-smart-analytics';

	require_once ABSPATH . 'wp-admin/includes/class-wp-filesystem-base.php';
	require_once ABSPATH . 'wp-admin/includes/class-wp-filesystem-direct.php';

	$file_system_direct = new WP_Filesystem_Direct( false );
	$file_system_direct->rmdir( $dir, true ); // Recursive deletion.

	global $wpdb;
	$table_name = $wpdb->prefix . 'smart_analytics_visitor_log';
	$wpdb->query( "DROP TABLE IF EXISTS $table_name" ); // Drop the table from the database.
}
